# GitLab HA Scaling Runner Vending Machine for AWS

> **Note:** The easy button code in this project is easy to reuse as a pattern to create your own easy button setups for the CloudFormation Console UI or the CLI.

> **Note:** That you can deploy as many of these as you wish as many times as you wish to build runner clusters with the appropriate attributes.

> **Note:** The automation that underlies the Easy Buttons complies with Amazon Well Architected and is capable of being used directly or as a template starting point for creating very advanced Runner ASGs.  Learn more here: https://gitlab.com/guided-explorations/aws/gitlab-runner-autoscaling-aws-asg

> **Note:** The easy buttons use default VPC, default subnets and default security groups. Once you've explored using an easy button, you will need to use the full template to specify these elements. See "**Not An Easy Button Person?**" below.

| Easy Buttons                                                                                                                                                                                                                                                                                                                                                          | Name                                                                                                       | Description                                                                                                                                                                                                                                                                                                          |
|-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|------------------------------------------------------------------------------------------------------------|----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| [![Arch_AWS-CloudFormation_32](./images/Arch_AWS-CloudFormation_32.png)](https://us-west-2.console.aws.amazon.com/cloudformation/home?region=us-west-2#/stacks/create/review?templateURL=https://gl-public-templates.s3.amazonaws.com/cfn/v1.5.5/easybutton-amazon-linux-2-docker-manual-scaling-with-schedule-ondemandonly.cf.yml&stackName=linux-docker-nonspot)    | Amazon Linux 2 Docker HA with Manual Scaling and Optional Scheduling. Non-spot.                            | Desired capacity of 1 enables WARM HA through ASG Respawn.<br />Desired capacity of 2 enables HOT HA since loss of a node does not make the service unavailable. <br />Desired capacity of 3 or more enables HOT HA and manual scaling of runner fleet. No Spot.<br />**Default choice for Linux Docker executor.**  |
| [![Arch_AWS-CloudFormation_32](./images/Arch_AWS-CloudFormation_32.png)](https://us-west-2.console.aws.amazon.com/cloudformation/home?region=us-west-2#/stacks/create/review?templateURL=https://gl-public-templates.s3.amazonaws.com/cfn/v1.5.5/easybutton-amazon-linux-2-docker-manual-scaling-with-schedule-spotonly.cf.yml&stackName=linux-docker-spotonly)       | Amazon Linux 2 Docker HA with Manual Scaling and Optional Scheduling. 100% spot.                           | Desired capacity of 1 enables WARM HA through ASG Respawn.<br />Desired capacity of 2 enables HOT HA since loss of a node does not make the service unavailable.<br />Desired capacity of 3 or more enables HOT HA and manual scaling of runner fleet. <br />**100% Spot.**                                          |
| [![Arch_AWS-CloudFormation_32](./images/Arch_AWS-CloudFormation_32.png)](https://us-west-2.console.aws.amazon.com/cloudformation/home?region=us-west-2#/stacks/create/review?templateURL=https://gl-public-templates.s3.amazonaws.com/cfn/v1.5.5/easybutton-windows2019-shell-manual-scaling-with-scheduling-ondemandonly.cf.yml&stackName=win2019-shell-non-spot)    | Windows 2019 Shell with Manual Scaling and Optional Scheduling. Scaling and Optional Scheduling. Non-spot. | Desired capacity of 1 enables WARM HA through ASG Respawn.<br />Desired capacity of 2 enables HOT HA since loss of a node does not make the service unavailable.<br />Desired capacity of 3 or more enables HOT HA and manual scaling of runner fleet. <br />**Default choice for Windows Shell executor.**          |
| [![Arch_AWS-CloudFormation_32](./images/Arch_AWS-CloudFormation_32.png)](https://us-west-2.console.aws.amazon.com/cloudformation/home?region=us-west-2#/stacks/create/review?templateURL=https://gl-public-templates.s3.amazonaws.com/cfn/v1.5.5/easybutton-windows2019-shell-manual-scaling-with-scheduling-spotonly.cf.yml&stackName=win2019-shell-spot)            | Windows 2019 Shell with Manual Scaling and Optional Scheduling. 100% spot.                                 | Desired capacity of 1 enables WARM HA through ASG Respawn.<br />Desired capacity of 2 enables HOT HA since loss of a node does not make the service unavailable.<br />Desired capacity of 3 or more enables HOT HA and manual scaling of runner fleet. <br />**100% Spot.**                                          |
| [![Arch_AWS-CloudFormation_32](./images/Arch_AWS-CloudFormation_32.png)](https://us-west-2.console.aws.amazon.com/cloudformation/home?region=us-west-2#/stacks/create/review?templateURL=https://gl-public-templates.s3.amazonaws.com/cfn/v1.5.5/easybutton-amazon-linux-2-arm64-docker-manual-scaling-with-schedule-spotonly.cf.yml&stackName=linux-docker-nonspot)  | **ARM64** Amazon Linux 2 Docker HA with Manual Scaling and Optional Scheduling. Non-spot.                  | Desired capacity of 1 enables WARM HA through ASG Respawn.<br />Desired capacity of 2 enables HOT HA since loss of a node does not make the service unavailable. <br />Desired capacity of 3 or more enables HOT HA and manual scaling of runner fleet.No Spot.                                                      |
| [![Arch_AWS-CloudFormation_32](./images/Arch_AWS-CloudFormation_32.png)](https://us-west-2.console.aws.amazon.com/cloudformation/home?region=us-west-2#/stacks/create/review?templateURL=https://gl-public-templates.s3.amazonaws.com/cfn/v1.5.5/easybutton-amazon-linux-2-arm64-docker-manual-scaling-with-schedule-spotonly.cf.yml&stackName=linux-docker-spotonly) | **ARM64** Amazon Linux 2 Docker HA with Manual Scaling and Optional Scheduling. 100% spot.                 | Desired capacity of 1 enables WARM HA through ASG Respawn.<br />Desired capacity of 2 enables HOT HA since loss of a node does not make the service unavailable.<br />Desired capacity of 3 or more enables HOT HA and manual scaling of runner fleet. <br />**100% Spot.**                                          |
|                                                                                                                                                                                                                                                                                                                                                                       | **More Advanced Options Including AutoScaling**                                                            |                                                                                                                                                                                                                                                                                                                      |
| [![Arch_AWS-CloudFormation_32](./images/Arch_AWS-CloudFormation_32.png)](https://us-west-2.console.aws.amazon.com/cloudformation/home?region=us-west-2#/stacks/create/review?templateURL=https://gl-public-templates.s3.amazonaws.com/cfn/v1.5.5/easybutton-amazon-linux-2-docker-simple-scaling-ondemand.cf.yml&stackName=linux-docker-scaling-spotonly)             | Amazon Linux 2 Docker Simple Scaling Ondemand Instances                                                    | Two docker executors, scaling based on simple CPU metrics, only spot<br />**Note:** Actual scaling parameters used in this MVP are just to show how to configure scaling - they are untested with Runner workloads - your can help by contributing your tested scaling parameters in an issue.                       |
| [![Arch_AWS-CloudFormation_32](./images/Arch_AWS-CloudFormation_32.png)](https://us-west-2.console.aws.amazon.com/cloudformation/home?region=us-west-2#/stacks/create/review?templateURL=https://media-smiler-staging.s3.amazonaws.com/cloudformation/easybutton-amazon-linux-2-docker-simple-scaling-spotonly.cf.yml)                                                | Amazon Linux 2 Docker Simple Scaling Spot Instances                                                        | Two docker executors, scaling based on simple CPU metrics, only spot<br />**Note:** Actual scaling parameters used in this MVP are just to show how to configure scaling - they are untested with Runner workloads - your can help by contributing your tested scaling parameters in an issue.                       |
| [![Arch_AWS-CloudFormation_32](./images/Arch_AWS-CloudFormation_32.png)](https://us-west-2.console.aws.amazon.com/cloudformation/home?region=us-west-2#/stacks/create/review?templateURL=https://gl-public-templates.s3.amazonaws.com/cfn/v1.5.5/easybutton-amazon-linux-2-docker-simple-scaling-spot-and-ondemand.cf.yml&stackName=linux-docker-scaling-both)        | Amazon Linux 2 Docker Simple Scaling Spot and Ondemand Instances (Mixed Instances)                         | Two docker executors, scaling based on simple CPU metrix, 50/50 mix of spot and ondemand.<br />**Note:** Actual scaling parameters used in this MVP are just to show how to configure scaling - they are untested with Runner workloads - your can help by contributing your tested scaling parameters in an issue.  |
| [![Arch_AWS-CloudFormation_32](./images/Arch_AWS-CloudFormation_32.png)](https://us-west-2.console.aws.amazon.com/cloudformation/home?region=us-west-2#/stacks/create/review?templateURL=https://gl-public-templates.s3.amazonaws.com/cfn/v1.5.5/easybutton-windows2019-shell-simple-scaling-ondemand.cf.yml&stackName=win2019-shell-scaling-nospot)                  | Windows 2019 Shell Simple Scaling Ondemand Instances                                                       | Two docker executors, scaling based on simple CPU metrics, no spot.<br />**Note:** Actual scaling parameters used in this MVP are just to show how to configure scaling - they are untested with Runner workloads - your can help by contributing your tested scaling parameters in an issue.                        |
| [![Arch_AWS-CloudFormation_32](./images/Arch_AWS-CloudFormation_32.png)](https://us-west-2.console.aws.amazon.com/cloudformation/home?region=us-west-2#/stacks/create/review?templateURL=https://gl-public-templates.s3.amazonaws.com/cfn/v1.5.5/easybutton-windows2019-shell-simple-scaling-spotonly.cf.yml&stackName=win2019-shell-scaling-spotonly)                | Windows 2019 Shell Simple Scaling Spot Instances                                                           | Two docker executors, scaling based on simple CPU metrics, only spot.<br />**Note:** Actual scaling parameters used in this MVP are just to show how to configure scaling - they are untested with Runner workloads - your can help by contributing your tested scaling parameters in an issue.                      |
| [![Arch_AWS-CloudFormation_32](./images/Arch_AWS-CloudFormation_32.png)](https://us-west-2.console.aws.amazon.com/cloudformation/home?region=us-west-2#/stacks/create/review?templateURL=https://gl-public-templates.s3.amazonaws.com/cfn/v1.5.5/easybutton-windows2019-shell-simple-scaling-spot-and-ondemand.cf.yml&stackName=win2019-shell-scaling-both)           | Windows 2019 Shell Simple Scaling Spot and Ondemand Instances (Mixed Instances)                            | Two docker executors, scaling based on simple CPU metrics, 50/50 mix of spot and ondemand.<br />**Note:** Actual scaling parameters used in this MVP are just to show how to configure scaling - they are untested with Runner workloads - your can help by contributing your tested scaling parameters in an issue. |

**Not An Easy Button Person?** If easy buttons aren't your thing, click here to load the full template in CloudFormation - the help text in the parameters gives a lot of information - but you may also need to consult this documentation: [![Arch_AWS-CloudFormation_32](./images/Arch_AWS-CloudFormation_32.png)](https://us-west-2.console.aws.amazon.com/cloudformation/home?region=us-east-1#/stacks/create/review?templateURL=https://gl-public-templates.s3.amazonaws.com/cfn/v1.5.5/GitLabElasticScalingRunner.cf.yml&stackName=GitLabElasticScalingRunner-AllParameters) (Recommended: add the tags Product=GitLab, Function=GitLabRunner)
